------------------------------------------------------------------
--
--	compassInterface.vhd
--  Rami Abielmona
--	May 4, 2003
--
------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.all;
use IEEE.STD_LOGIC_UNSIGNED.all;

entity compassInterface is
	port (	i_clock10Khz	: in	std_logic;
			i_pwmSignal		: in	std_logic;
			o_angle			: out	std_logic_vector(8 downto 0)
		 );
end compassInterface;

architecture behave of compassInterface is

	signal int_count	: std_logic_vector(8 downto 0);
	type state_type 	is (waitingForEdge, readingAngle);
	signal state		: state_type := waitingForEdge;

begin
	
	process
		begin
			wait until i_clock10Khz'event AND i_clock10Khz='1';
				case state is

					when waitingForEdge =>
						if (i_pwmSignal = '0') then
							int_count <= int_count + 1;
						elsif (i_pwmSignal = '1') then
							int_count <= "000000001";
							state <= readingAngle;
						end if;

					when readingAngle =>
						if (i_pwmSignal = '1') then
							int_count <= int_count + 1;
						elsif (i_pwmSignal = '0') then
							o_angle <= int_count;
							int_count <= "000000001";
							state <= waitingForEdge;
						end if;
				end case;
		end process;

end behave;






