LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY sonar_input IS
	PORT	(clock				:IN	STD_LOGIC;
			distance			:OUT STD_LOGIC_VECTOR(15 downto 0);   
			valid_distance 		:OUT STD_LOGIC;
			get_distance 		:IN STD_LOGIC;
			init, blnk, binh	:OUT STD_LOGIC;
			echo				:IN STD_LOGIC);
END sonar_input;

ARCHITECTURE a OF sonar_input IS	
BEGIN
	PROCESS
		constant period: 	integer := 10;   	--in ns
		constant speed: 	integer := 240;     --m/s
        constant dis_max:	integer	:= 20000;
		variable distance1: 	integer;
		variable distance2: 	std_logic_vector(15 downto 0);
		variable pulses:	integer;
        
		BEGIN
			WAIT UNTIL clock'EVENT AND clock = '1';
			IF (get_distance = '1') THEN
				init <= '1';
				blnk <= '0';
				binh <= '0';
			else
				init <= '0';
				blnk <= '0';
				binh <= '0';
			END IF;
			IF (echo = '1') then
				distance1 := speed*pulses*period/2;
				pulses := 0;
	            IF distance1 > dis_max then
    	           distance1 := dis_max;
        	 	end if;
				valid_distance <= '1';
			distance2 := conv_std_logic_vector(distance1, 16);
	 	   	distance <= distance2;
			else
				distance <= "0000000000000000";
			end if;
			pulses := pulses + 1; 
	end process;
end a;


